/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.javagui;

import java.lang.reflect.Method;

import java.util.Comparator;

import com.funambol.foundation.pdi.contact.Contact;

/**
 * Contact comparator.
 * <br/>
 * Compares contacts using displayName
 * <br/>
 *
 *
 *
 * @version $Id: ContactComparator.java,v 1.3 2006/09/07 09:03:05 luigia Exp $
 */

public class ContactComparator implements Comparator {

    // ------------------------------------------------------------ Private data

    // ------------------------------------------------------------- Constructor
    /**
     * Creates a new ContactComparator.
     */
    public ContactComparator() {

    }

    // --------------------------------------------------------- Public methods

    /**
     * Compares its two arguments for order.
     *
     * @param o1 the first object to be compared.
     * @param o2 the second object to be compared.
     * @return a negative integer, zero, or a positive integer as the first
     *   argument is less than, equal to, or greater than the second.
     */
    public int compare(Object o1, Object o2) {

        String value1    = null;
        String value2    = null;

        String firstName = null;
        String lastName  = null;



        value1 = (String) ((DemoContact) o1).getContact().getName().
                                        getDisplayName().getPropertyValue();

        value2 = (String) ((DemoContact) o2).getContact().getName().
                                        getDisplayName().getPropertyValue();


        if (value1 == null) {

            value1 = (String) ((DemoContact) o1).getContact().getName().
                        getLastName().getPropertyValue();

            if (value1 != null && !value1.equals("")) {
                value1 += ",";
            }

            value1 += (String) ((DemoContact) o1).getContact().getName().
                        getFirstName().getPropertyValue();

            if (value1 == null) {
                value1 = "";
            }

        }

        if (value2 == null) {

            value2 =(String) ((DemoContact) o2).getContact().getName().
                        getLastName().getPropertyValue();

            if (value2 != null && !value1.equals("")) {
                value2 += ",";
            }

            value2 += (String) ((DemoContact) o2).getContact().getName().
                        getFirstName().getPropertyValue();

            if (value2 == null) {
                value2 = "";
            }

        }

        return (value1.toUpperCase()).compareTo(value2.toUpperCase());

    }

    // --------------------------------------------------------- Private methods

}
