/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.syncclient.javagui;

import com.funambol.foundation.pdi.event.Calendar;

/**
 * An object representing a calendar.
 * Each calendar is identified by its filename
 * and the calendar itself in the form of a Calendar object.
 *
 * @see com.funambol.foundation.pdi.event.Calendar
 *
 * @version $Id: DemoCalendar.java,v 1.3 2006/09/07 09:03:05 luigia Exp $
 */
public class DemoCalendar {

    //------------------------------------------------------------- Private data

    private String    filename  = null ;
    private Calendar  calendar  = null ;

    //----------------------------------------------------------- Public methods

    /**
     * Creates a new calendar
     *
     * @param filename the filename for this calendar
     * @param calendar the Calendar object for this calendar
     */
    public DemoCalendar(String filename, Calendar calendar) {
        this.filename = filename;
        this.calendar = calendar;
    }

    /**
     * Returns the filename for this calendar
     *
     * @return the filename for this calendar
     */
    public String getFilename() {
        return filename;
    }

    /**
     * Returns the calendar object for this calendar
     *
     * @return the calendar object for this calendar
     */
    public Calendar getCalendar() {
        return calendar;
    }

    /**
     * Sets the calendar objecy of this calendar
     *
     * @param calendar the calendar object to set
     */
    public void setCalendar(Calendar calendar) {
        this.calendar = calendar;
    }

}
